//+------------------------------------------------------------------+
//|                                                         Test All |
//|                   Copyright 2000-2015, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#include "stdafx.h"

#define MAX_SIZE 168
//--- matrices
int m1[MAX_SIZE][MAX_SIZE],m2[MAX_SIZE][MAX_SIZE],mm[MAX_SIZE][MAX_SIZE];
//+------------------------------------------------------------------+
//| Test function                                                    |
//+------------------------------------------------------------------+
void TestMatrixX()
  {
   int i,j,k,val;
//--- multiplication of matrices
   for(i=0;i<MAX_SIZE;i++)
     {
      for(j=0;j<MAX_SIZE;j++)
        {
         val=0;
         for(k=0;k<MAX_SIZE;k++)
           {
            val+=m1[i][k]*m2[k][j];
           }
         mm[i][j]=val;
        }
     }
  }
//+------------------------------------------------------------------+
//| OnStart function                                                 |
//+------------------------------------------------------------------+
DWORD TestMatrix()
  {
   int   i,j,n=1;
   DWORD tick_count,res;
//--- test
   tick_count=GetTickCount();
   for(i=0;i<MAX_SIZE;i++)
      for(j=0;j<MAX_SIZE;j++)
        {
         m1[i][j]=n;
         m2[i][j]=n;
         n++;
        }
   for(i=0;i<MAX_SIZE;i++)
      TestMatrixX();
   res=GetTickCount()-tick_count;
//--- returns test execution time, in milliseconds
   return(res);
  }
//+------------------------------------------------------------------+
