//+------------------------------------------------------------------+
//|                                                         Test All |
//|                   Copyright 2000-2015, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#include "stdafx.h"

#define MAX_SIZE 22000
//---
std::string str;
int         a[(MAX_SIZE/4+1)*14];
//+------------------------------------------------------------------+
//| Test function                                                    |
//+------------------------------------------------------------------+
bool PiCalculate(const int digits)
  {
   int d=0,e,b,g,r;
   int c=(digits/4+1)*14;
   int f=10000;
//---
   for(int i=0;i<c;i++)
      a[i]=20000000;
//---
   while((b=c-=14)>0)
     {
      d=e=d%f;
      while(--b>0)
        {
         d=d * b + a[b];
         g=(b << 1) - 1;
         a[b]=(d%g)*f;
         d/=g;
        }
      r=e+d/f;
      if(r<1000)
        {
         if(r>99) str+="0";
         else
           {
            if(r > 9) str+="00";
            else      str+="000";
           }
        }
      str+=std::to_string(r);
     }
//---
   return(true);
  }
//+------------------------------------------------------------------+
//| OnStart function                                                 |
//+------------------------------------------------------------------+
DWORD TestPiCalculate()
  {
   DWORD tick_count,res;
//--- test
   tick_count=GetTickCount();
   PiCalculate(MAX_SIZE);
   res=GetTickCount()-tick_count;
//--- returns test execution time, in milliseconds
   return(res);
  }
//+------------------------------------------------------------------+
