//+------------------------------------------------------------------+
//|                                                         Test All |
//|                   Copyright 2000-2015, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#include "stdafx.h"

#define MAX_SIZE 10000
//---
#define IM 139968
#define IA 3877
#define IC 29573
//+------------------------------------------------------------------+
//| Test function                                                    |
//+------------------------------------------------------------------+
double TestRandom2(double max)
  {
   static long last=42;
//---
   last=(last*IA+IC)%IM;
   return(max*last/IM);
  }
//+------------------------------------------------------------------+
//| OnStart function                                                 |
//+------------------------------------------------------------------+
DWORD TestRandom()
  {
   int   i,j,n=1;
   DWORD tick_count,res;
//--- test
   tick_count=GetTickCount();
   for(i=0;i<MAX_SIZE;i++)
      for(j=0;j<MAX_SIZE;j++)
         TestRandom2(i+j);
   res=GetTickCount()-tick_count;
//--- returns test execution time, in milliseconds
   return(res);
  }
//+------------------------------------------------------------------+
