//+------------------------------------------------------------------+
//|                                                         Test All |
//|                   Copyright 2000-2015, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#include "stdafx.h"

#define MAX_SIZE 14000000
//+------------------------------------------------------------------+
//| Test function                                                    |
//+------------------------------------------------------------------+
void TestStrPrep(std::string &str)
  {
   int  i,c,nl,nw,nc;
   bool space;
//---
   space=true;
   nl=nw=nc=0;
//---
   nc+=strlen(str.c_str());
   for(i=0; i<nc; i++)
     {
      c=str.at(i);
      if(c=='\n')
         ++nl;
      if(c==' ' || c=='\r' || c=='\n' || c=='\t' || c=='\"')
         space=true;
      else
        {
         if(space)
           {
            space=false;
            ++nw;
           }
        }
     }
  }
//+------------------------------------------------------------------+
//| OnStart function                                                 |
//+------------------------------------------------------------------+
DWORD TestStrPrep()
  {
   DWORD        tick_count,res;
   std::string  str="Print(\"String parsing test \",res,\" ms.\");";
//--- test
   tick_count=GetTickCount();
   for(int i=0;i<MAX_SIZE;i++)
      TestStrPrep(str);
   res=GetTickCount()-tick_count;
//--- returns test execution time, in milliseconds
   return(res);
  }
//+------------------------------------------------------------------+
